//
//  DetailViewController.h
//  AnalogSynthesizerPad
//
//  Created by 成田 拓郎 on 10/07/19.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "KeyboardView.h"
#import "VolumeView.h"
#import "SynthesizerOutput.h"

@interface DetailViewController : UIViewController <UIPopoverControllerDelegate, UISplitViewControllerDelegate> {
    
    UIPopoverController *popoverController;
    UIToolbar *toolbar;

	KeyboardView *keyboardView;

	VolumeView *vcoWaveTypeVolumeView;
	VolumeView *vcoPulseWidthVolumeView;
	VolumeView *vcoControlLevelVolumeView;
	
	VolumeView *vcfCutOffFrequencyVolumeView;
	VolumeView *vcfResonanceVolumeView;
	VolumeView *vcfControlLevelVolumeView;
	
	VolumeView *vcaControlLevelVolumeView;
	
	VolumeView *egParamAttackVolumeView;
	VolumeView *egParamDecayVolumeView;
	VolumeView *egParamSustainVolumeView;
	VolumeView *egParamReleaseVolumeView;
	
	VolumeView *lfoWaveTypeVolumeView;
	VolumeView *lfoPulseWidthVolumeView;
	VolumeView *lfoFrequencyVolumeView;
	
	VolumeView *echoDelayTimeVolumeView;
	VolumeView *echoDelayLevelVolumeView;
	
	SynthesizerOutput *synthesizerOutput;

	CGPoint volumeCenter[16];
}

@property (nonatomic, retain) IBOutlet UIToolbar *toolbar;
@property (nonatomic, retain) IBOutlet KeyboardView *keyboardView;

@property (nonatomic, retain) IBOutlet VolumeView *vcoWaveTypeVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *vcoPulseWidthVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *vcoControlLevelVolumeView;

@property (nonatomic, retain) IBOutlet VolumeView *vcfCutOffFrequencyVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *vcfResonanceVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *vcfControlLevelVolumeView;

@property (nonatomic, retain) IBOutlet VolumeView *vcaControlLevelVolumeView;

@property (nonatomic, retain) IBOutlet VolumeView *egParamAttackVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *egParamDecayVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *egParamSustainVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *egParamReleaseVolumeView;

@property (nonatomic, retain) IBOutlet VolumeView *lfoWaveTypeVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *lfoPulseWidthVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *lfoFrequencyVolumeView;

@property (nonatomic, retain) IBOutlet VolumeView *echoDelayTimeVolumeView;
@property (nonatomic, retain) IBOutlet VolumeView *echoDelayLevelVolumeView;

@property (nonatomic, retain) SynthesizerOutput *synthesizerOutput;

- (void)selectRootView:(int)row;
- (void)keyboardChanged:(id)sender;

-(void)vcoWaveTypeChanged:(id)sender;
-(void)vcoPulseWidthChanged:(id)sender;
-(void)vcoControlLevelChanged:(id)sender;

-(void)vcfCutOffFrequencyChanged:(id)sender;
-(void)vcfResonanceChanged:(id)sender;
-(void)vcfControlLevelChanged:(id)sender;

-(void)vcaControlLevelChanged:(id)sender;

-(void)egParamAttackChanged:(id)sender;
-(void)egParamDecayChanged:(id)sender;
-(void)egParamSustainChanged:(id)sender;
-(void)egParamReleaseChanged:(id)sender;

-(void)lfoWaveTypeChanged:(id)sender;
-(void)lfoPulseWidthChanged:(id)sender;
-(void)lfoFrequencyChanged:(id)sender;

-(void)echoDelayTimeChanged:(id)sender;
-(void)echoDelayLevelChanged:(id)sender;

@end
